import astropy,os,scipy,scipy.interpolate
import numpy as np
from astropy.io import fits

os.system('ls e*.fits > fits.lst')

filename=open('fits.lst','r')
date=next(filename)[1:5]
filename.close()

num_flat=[0,0,0,0,0]
name_filter=['g','bokr','r','z','u']
skylevel_filter=[5000.,5000.,5000.,5000.,1000.]

#flat_median=np.empty((500,16))
flat_mean=np.empty((16))

for line in open("fits.lst"):
    line=line.strip("\n")
    if (fits.getval(line,'IMAGETYP',0) != 'flat') and (fits.getval(line,'IMAGETYP',0) != 'zero') and (fits.getval(line,'OBJECT',0) != ''):
        filter=fits.getval(line,'FILTER',0)
        fits_file=fits.open(line)

        for i in range(5):
            if (filter == name_filter[i]) and (np.median(fits_file[1].data[100:1900,100:1900] <= skylevel_filter[i])):
                num_flat[i]+=1

print(num_flat)

for i in range(5):
    if (num_flat[i] >= 50):

        flat_median=np.empty((500,16))
        flat_mean=np.empty((16))
        flat_name='flat_'+date+'_'+name_filter[i]+'_sky.fits'
        print(flat_name)

        for k in range(16):
            print('CCD  ',k+1)
            list=[]
            flat1_all=np.empty((2048,2036))
            j=0
            for line in open("fits.lst"):
                line=line.strip("\n")
                object=fits.getval(line,'IMAGETYP',0)
                filter=fits.getval(line,'FILTER',0)
                if (object != 'flat') and (object != 'bias') and (object != 'zero') and (filter == name_filter[i]):
                    flat=fits.open(line)
#                    filter=flat[0].header['FILTER']
                    if (j == 0) and  (k == 0):
                        flat1=flat

                    data=flat[k+1].data[:2048,:2036]

                    flat_median[j,k]=np.median(data[100:1900,100:1900])

                    if (flat_median[j,k] <= skylevel_filter[i]):

                        data/=np.median(data[100:1900,100:1900])

                        list.append(data)
                        j=j+1

            flat_all=np.array(list)

##    for m in range(2048):
##        for n in range(2036):
##            zero1[k+1].data[m,n]=np.median(bias[0:,m,n])

            flat_all.sort(0)#np.median(bias[0:])
            flat1_all=0.5*(flat_all[(j-1)/2,:,:]+flat_all[j/2,:,:])
            flat1_all[flat1_all == 0.0] = 1.0

            flat1[k+1].data[:2048,:2036]=flat1_all[:2048,:2036]

#for k in range(16):
#    flat_mean[k]=np.median(flat_median[0:j-1,k])

        for k in range(16):
            data=flat[k+1].data
            flat[k+1].data[:2048,:2036]=flat1[k+1].data[:2048,:2036]#*flat_mean[k]/np.mean(flat_mean)
        
        flat[0].header['IMAGETYP']='flat'
        flat[0].header['OBJECT']='flat'
        flat.writeto(flat_name,clobber='Ture')

        flat.close()


